package dareka.launcher.logview;

import java.awt.Font;
import java.awt.Rectangle;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JViewport;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import dareka.launcher.IconImage;

public class LogWindow {

	private static final int MAX_LINE = 1024;
	
	private static LogWindow instance = new LogWindow();

	private JFrame frame;
	private JTextArea textArea;
	private JScrollPane scrollPane;
	private JViewport viewpoint;

	private int lastScrollHeight = -1;
	private int lastViewHeight = -1;
	private boolean changedFlg = false;

	private LogWindow() {
		frame = new JFrame("NicoCacheO");
		frame.setBounds(16, 16, 640, 480);
		frame.setIconImage(IconImage.getImage());
		frame.setAlwaysOnTop(true);

		Font font = new Font(Font.MONOSPACED, Font.PLAIN, 16);

		textArea = new JTextArea();
		textArea.setFont(font);

		scrollPane = new JScrollPane(textArea);
		viewpoint = scrollPane.getViewport();

		// Viewpoint̃Cxgɍ킹ăXN[𒲐
		{
			viewpoint.addChangeListener(new ChangeListener() {

				@Override
				public void stateChanged(ChangeEvent arg0) {
					Rectangle rect = viewpoint.getViewRect();

					// eƕ\ƃEChETCYωĂȂΈȍ~̏͂Ȃ
					if (lastScrollHeight == textArea.getHeight()
						&& lastViewHeight == rect.height
						&& changedFlg == false) return;

					// TODO fobOp
					if (Boolean.getBoolean("dareka.debug")) {
						System.out.println("lastScrollHeight:" + lastScrollHeight);
						System.out.println("lastViewHeight  :" + lastScrollHeight);
						System.out.println("textArea.getHeight:" + textArea.getHeight());
						System.out.println("rect.y     :" + rect.y);
						System.out.println("rect.height:" + rect.height);
					}

					// ǋLÕXN[ʒuԉ̏ꍇAǋLɍ킹ăXN[ړ
					if (lastScrollHeight - lastViewHeight == rect.y) {
						rect.setLocation(rect.x, textArea.getHeight() - rect.height);
						textArea.scrollRectToVisible(rect);
					}

					lastScrollHeight = textArea.getHeight();
					lastViewHeight = rect.height;
					changedFlg = false;
				}

			});
		}

		frame.add(scrollPane);
	}

	public static LogWindow getInstance() {
		return instance;
	}

	public void show() {
		// EChE\
		frame.setVisible(true);
		// EChE̍ŏ߂
		frame.setState(JFrame.NORMAL);
	}

	public synchronized void appendLog(String log) {
		// TODO AČĂяoƌ\dEEE
		//      fobO[hȂ΂܂CɂȂȂA΍􂪕KvȁB
		
		// eLXgGAɃOǋL
		textArea.append(log);
		
		// ő働Os𒴂擪珇ɍ폜
		if (textArea.getLineCount() > MAX_LINE) {
			try {
				int offset = textArea.getLineEndOffset(
						textArea.getLineCount() - MAX_LINE - 1);
				textArea.getDocument().remove(0, offset);
			} catch (Exception ex) {
				ex.printStackTrace();
			} 
		}
		
		//@eύXς݃tO𗧂Ă
		changedFlg = true;
		
		// TODO fobOp
		if (Boolean.getBoolean("dareka.debug")) {
			frame.setTitle("NicoCacheO ( " + textArea.getLineCount() + " /" + MAX_LINE + ")");
		}
	}

	public void close() {
		instance = null;

		frame.dispose();
		frame = null;
	}

	public Rectangle getBounds() {
		return frame.getBounds();
	}

	public void setBounds(Rectangle r) {
		frame.setBounds(r);
	}

}
